/************************************************************************
 *  TEST_CNV.C								*
 *			Test von Umwandlungs-Funktionen 		*
 *			=============================== 		*
 *									*
 *  01.04.94	Bodo Wenzel	Erstellung (spezielle Version 51I)	*
 ************************************************************************/

/* === Einfgedateien ================================================= */

#include "stdio.h"
#include "stdlib.h"

/* === Funktionsprototypen ============================================ */

puts_c(char *s);
str_c1(char *s);
str_c2(char *s);

i2s(int i);
s2i(char *s);
iss(int i,char *s1,char *s2);
ssii(char *s1,char *s2,int i1,int i2);
hex(int n);
nib(int n);

/* === M A I N ======================================================== */

main()
/*--*/
  {
  getchar();

  for (;;)
    {
    puts_c("Gestartet...\r\n");

    i2s(0);
    i2s(123);
    i2s(-123);
    i2s(32767);
    i2s(-32767);

    s2i(str_c1(""));
    s2i(str_c1("0"));
    s2i(str_c1("+0"));
    s2i(str_c1("-0"));
    s2i(str_c1("1111011"));
    s2i(str_c1("+1111011"));
    s2i(str_c1("-1111011"));
    s2i(str_c1("173"));
    s2i(str_c1("+173"));
    s2i(str_c1("-173"));
    s2i(str_c1("123"));
    s2i(str_c1("+123"));
    s2i(str_c1("-123"));
    s2i(str_c1("7B"));
    s2i(str_c1("+7B"));
    s2i(str_c1("-7B"));
    s2i(str_c1("9999"));
    s2i(str_c1("FFF"));
    s2i(str_c1("111111111111111"));
    s2i(str_c1("77777"));
    s2i(str_c1("32767"));
    s2i(str_c1("7FFF"));
    s2i(str_c1("Teststring"));
    s2i(str_c1("-Teststring"));
    s2i(str_c1("+Teststring"));
    }
  }

/* === Hilfsfunktionen ================================================ */

puts_c(char *s)
/*-----------*/
  {
  char	c;

  while (c=s++
#asm
	mov	dph,b
	mov	dpl,a
	mov	b,#0
	clr	a
	movc	a,@a+dptr
#endasm
	    )
    putchar(c);
  }

char	str1[20],str2[10];

str_c1(char *s)
/*-----------*/
  {
  char	*p;

  p=str1;
  while (*p++=s++
#asm
	mov	dph,b
	mov	dpl,a
	mov	b,#0
	clr	a
	movc	a,@a+dptr
#endasm
	    );
  return(str1);
  }

str_c2(char *s)
/*-----------*/
  {
  char	*p;

  p=str2;
  while (*p++=s++
#asm
	mov	dph,b
	mov	dpl,a
	mov	b,#0
	clr	a
	movc	a,@a+dptr
#endasm
	    );
  return(str2);
  }

/* === Konvertierungen ================================================ */

i2s(int i)
/*------*/
  {
  char	s[100];

  itostr(s,2,i);
  iss(i,str_c2("B"),s);
  itostr(s,8,i);
  iss(i,str_c2("O"),s);
  itostr(s,10,i);
  iss(i,str_c2("D"),s);
  itostr(s,16,i);
  iss(i,str_c2("H"),s);
  getchar();
  }

s2i(char *s)
/*--------*/
  {
  int	i,v;

  i=0;
  v=strtoi(s,2,&i);
  ssii(s,str_c2("B"),v,i);
  i=0;
  v=strtoi(s,8,&i);
  ssii(s,str_c2("O"),v,i);
  i=0;
  v=strtoi(s,10,&i);
  ssii(s,str_c2("D"),v,i);
  i=0;
  v=strtoi(s,16,&i);
  ssii(s,str_c2("H"),v,i);
  getchar();
  }

iss(int i,char *s1,char *s2)
/*------------------------*/
  {
  hex(i);
  putchar('(');
  puts(s1);
  puts_c(")=>\"");
  puts(s2);
  puts_c("\"\r\n");
  }

ssii(char *s1,char *s2,int i1,int i2)
/*---------------------------------*/
  {
  puts_c("\"");
  puts(s1);
  puts_c("\"(");
  puts(s2);
  puts_c(")=>");
  hex(i1);
  putchar('(');
  hex(i2);
  puts_c(")\r\n");
  }

/* === Ausgabefunktionen ============================================== */

hex(int n)
/*------*/
  {
  if (n<0)
    {
    n=-n;
    putchar('-');
    }
  else
    putchar('+');
  nib(n>>12);
  nib(n>>8);
  nib(n>>4);
  nib(n);
  }

nib(int n)
/*------*/
  {
  n=n&15;
  if (n<10)
    putchar(n+'0');
  else
    putchar(n-10+'A');
  }

/* === Ende =========================================================== */
