/************************************************************************
 *  SSCANF.C                                                            *
 *                  STDIO-Funktion sscanf() (fr PINC)                  *
 *                  ==================================                  *
 *                                                                      *
 *  15.06.93    Bodo Wenzel     Erstellung                              *
 ************************************************************************/

#include "ctype.h"
#include "stdio.h"
#include "stdlib.h"
#include "string.h"

/* -------------------------------------------------------------------- */
/*      sscanf()        liest ein formatiertes Argument, liefert die    */
/*                      Anzahl der eingelesenen Zeichen, EOF bei        */
/*                      Fehlern, 0 bei Formatfehlern                    */
/*      s               Zeiger auf den Quellpuffer                      */
/*      format          Zeiger auf die Formatangabe                     */
/*      arg             (als int vereinbart) Zeiger auf das Argument    */

sscanf(char *s,char *format,int *arg)
/*---------------------------------*/
  {
  char  *p,c,*cptr;
  int   width,len;

  p=s;
  while (*format)
    {
    if (*format==' ')
      {
      ++format;
      continue;
      }
    if (*p=='\0')
      return(EOF);
    if (*format!='%')
      {
      while (isspace(*p))
        ++p;
      if (*p=='\0')
        return(EOF);
      if (*p!=*format)
        break;
      ++p;
      ++format;
      continue;
      }
    if (*++format=='%')
      {
      while (isspace(*p))
        ++p;
      if (*p=='\0')
        return(EOF);
      if (*p!='%')
        break;
      ++p;
      ++format;
      continue;
      }
    width=0;
    if (isdigit(*format))
      {
      len=0;
      width=strtoi(format,10,&len);
      format=format+len;
      }
    if ((c=*format++)=='\0')
      break;
    switch (c)
      {
      case 'd':
        --p;
        while (isspace(*++p));
        *arg=strtoi(p,10,&width);
        break;
      case 'x':
        --p;
        while (isspace(*++p));
        *arg=strtoi(p,16,&width);
        break;
      case 'c':
        if (width==0)
          width=1;
        len=-1;
        while (p[++len]);
        if (width>len)
          width=len;
        strncpy(arg,p,width);
        break;
      case 's':
        --p;
        while (isspace(*++p));
        len=0;
        while ((c=p[len])!='\0' & isspace(c)==0)
          ++len;
        if (width==0 | width>len)
          width=len;
        cptr=arg;
        strncpy(cptr,p,width);
        cptr[width]='\0';
        break;
      default:
        width=0;
      }
    if (width==0)
      break;
    p=p+width;
    }
  if (*format)
    return(0);
  else
    return(p-s);
  }

/* === Ende =========================================================== */
