/************************************************************************
 *  MACHINE.H, letzte nderung 22.08.93                                 *
 *                                                                      *
 *                      Codeausgabe fr PINC                            *
 *                      ====================                            *
 *                                                                      *
 ************************************************************************/

/* === Konstanten ===================================================== */

#define T_NAME  0               /* Name der Tabelle                     */
#define T_COMM  1               /* Kommentar                            */
#define T_BCODE 2               /* Anfang Programm                      */
#define T_ECODE 3               /* Ende Programm                        */
#define T_BDATA 4               /* Anfang Konstanten                    */
#define T_EDATA 5               /* Ende Konstanten                      */
#define T_BBSS  6               /* Anfang Variablen                     */
#define T_EBSS  7               /* Ende Variablen                       */
#define T_END   8               /* Ende des Ausgabetextes               */
#define T_XFUNC 9               /* externe Funktion                     */
#define T_XINT  10              /* externer "int"                       */
#define T_XCHR  11              /* externer "char"                      */
#define T_PFUNC 12              /* globale Funktion                     */
#define T_PINT  13              /* globaler "int"                       */
#define T_PCHR  14              /* globaler "char"                      */
#define T_LABEL 15              /* Sprungziel                           */
#define T_CLBL  16              /* "char"-Label                         */
#define T_DCHR  17              /* konstante "char"                     */
#define T_DIST  18              /* Platz fr "int"                      */
#define T_DCST  19              /* Platz fr "char"                     */
#define T_LGADR 20              /* lade Funktionsadresse                */
#define T_LDADR 21              /* lade Konstantendresse                */
#define T_LLADR 22              /* lade lokale Adresse                  */
#define T_LAINT 23              /* lade globalen "int"                  */
#define T_LACHR 24              /* lade globalen "char"                 */
#define T_SAINT 25              /* speichere globalen "int"             */
#define T_SACHR 26              /* speichere globalen "char"            */
#define T_LIINT 27              /* lade indirekt "int"                  */
#define T_LICHR 28              /* lade indirekt "char"                 */
#define T_SIINT 29              /* speichere indirekt "int"             */
#define T_SICHR 30              /* speichere indirekt "char"            */
#define T_CPTR  31              /* konvertiere Index fr "int"          */
#define T_PUSH  32              /* Wert in Stack schieben               */
#define T_CORSP 33              /* Stackpointer ndern                  */
#define T_CALL  34              /* globale Funktion aufrufen            */
#define T_CALLS 35              /* indirekte Funktion aufrufen          */
#define T_RET   36              /* Rcksprung                           */
#define T_JUMP  37              /* Sprung                               */
#define T_FJUMP 38              /* Sprung, wenn falsch                  */
#define T_TJUMP 39              /* Sprung, wenn wahr                    */
#define T_CPIMM 40              /* obersten Stackwert verdoppeln        */
#define T_NEJMP 41              /* Sprung, wenn ungleich                */
#define T_LIMM  42              /* lade Wert                            */
#define T_ADD   43              /* addiere                              */
#define T_SUB   44              /* subtrahiere                          */
#define T_MUL   45              /* multipliziere                        */
#define T_DIV   46              /* dividiere                            */
#define T_MOD   47              /* modulo berechnen                     */
#define T_OR    48              /* oder                                 */
#define T_XOR   49              /* exklusiv oder                        */
#define T_AND   50              /* und                                  */
#define T_SHR   51              /* rechts schieben                      */
#define T_SHL   52              /* links schieben                       */
#define T_NEG   53              /* negiere                              */
#define T_INC   54              /* Wert erhhen                         */
#define T_INCI  55              /* "int"-Zeiger erhhen                 */
#define T_DEC   56              /* Wert erniedrigen                     */
#define T_DECI  57              /* "int"-Zeiger erniedrigen             */
#define T_EQ    58              /* gleich                               */
#define T_NE    59              /* ungleich                             */
#define T_SLT   60              /* Wert kleiner                         */
#define T_SLE   61              /* Wert kleiner-gleich                  */
#define T_SGT   62              /* Wert grer                          */
#define T_SGE   63              /* Wert grer-gleich                   */
#define T_ULT   64              /* Zeiger kleiner                       */
#define T_ULE   65              /* Zeiger kleiner-gleich                */
#define T_UGT   66              /* Zeiger grer                        */
#define T_UGE   67              /* Zeiger grer-gleich                 */
#define TABMAX  68

/* === Globale Variablen ============================================== */

extern  int     mstackdir,      /* Richtung des Stacks                  */
                mintwidth,      /* Breite eines "int"s                  */
                mretwidth,      /* Breite einer Rcksprungadresse       */
                mcharoff,       /* Offset eines "char"s im "int"        */
                mcharaln;       /* Stackanpassung fr "char"s           */

/* === Funktionsprototypen ============================================ */

mreadtab(char *name);           /* Tabelle lesen                        */
mheader(char *arg);             /* Kopf ausgeben                        */
mextfuncs();                    /* Externe Funktionsnamen ausgeben      */
mdataout();                     /* Konstanten ausgeben                  */
mbssout();                      /* Globale Variablen ausgeben           */
mtrailer();                     /* Ende ausgeben                        */

mgetgbl(char *s);               /* PRI = globale Variable               */
mputgbl(char *s);               /* Globale Variable = PRI               */
mgetgadr(char *s);              /* PRI = globale Adresse                */
mgetladr(char *s);              /* PRI = lokale Adresse                 */
mgetdadr(int offs);             /* PRI = Konstantenadresse              */
mgetind(char type);             /* PRI = *PRI                           */
mputind(char type);             /* *TOS = PRI                           */

mpush();                        /* PRI in Stack                         */
mpop();                         /* Ein Wert vom Stack                   */
mmodifysp(int newsp);           /* Stackpointer verndern               */

moutcmd(int cmd);               /* Code ausgeben                        */
moutcmdn(int cmd,char *n);      /* Code und Symbolnamen ausgeben        */
moutcmdl(int cmd,int l);        /* Code und Sprungmarke ausgeben        */
moutcmdv(int cmd,int v);        /* Code und Wert ausgeben               */
moutcmds(int cmd,char *s);      /* Code und Text ausgeben               */

moutstr(char *s);               /* Zeichenkette ausgeben                */
mouteol();                      /* Zeilenende ausgeben                  */

/* === Ende =========================================================== */
