/************************************************************************
 *  TEST_ALU.C                                                          *
 *                      Test von Arithmetik und Logik                   *
 *                      =============================                   *
 *                                                                      *
 *  26.06.93    Bodo Wenzel     Erstellung                              *
 ************************************************************************/

#include "stdio.h"

/* === Funktionsprototypen ============================================ */

arith(int i1,int i2);
logic(int i1,int i2);
log_int(int i1,int i2);
log_ptr(char *p1,char *p2);
log(int l);
hex(int n);
nib(int n);

/* === M A I N ======================================================== */

main()
/*--*/
  {
  char  *pc;
  int   *pi;

  arith(0x123,0x456);
  arith(0x456,0x123);
  arith(1,0);
  arith(0,1);
  arith(1,1);
  arith(32767,1);
  arith(1,32767);
  arith(32767,32767);

  logic(0x123,0x456);
  logic(0x456,0x123);
  logic(1,32767);

  puts("\r\n123<<4=");
  hex(0x123<<4);
  puts("\r\n123>>4=");
  hex(0x123>>4);
  pc=0x123;
  puts("\r\n++123=");
  hex(++pc);
  puts("\r\n--124=");
  hex(--pc);
  puts("\r\n123++=");
  hex(pc++);
  puts("\r\n124--=");
  hex(pc--);
  pi=0x456;
  puts("\r\n++456=");
  hex(++pi);
  puts("\r\n--45x=");
  hex(--pi);
  puts("\r\n456++=");
  hex(pi++);
  puts("\r\n45x--=");
  hex(pi--);
  getchar();

  log_int(0,1);
  log_int(0,-1);
  log_int(1,0);
  log_int(-1,0);
  log_int(1,1);

  log_ptr(0,1);
  log_ptr(0,-1);
  log_ptr(1,0);
  log_ptr(-1,0);
  log_ptr(1,1);
  puts("\r\n");
  return(0);
  }

/* === Arithmetik ===================================================== */

arith(int i1,int i2)
/*----------------*/
  {
  puts("\r\nArithmetik mit ");
  hex(i1);
  puts(" und ");
  hex(i2);
  puts(":\r\nAddition:       ++=");
  hex(i1 + i2);
  puts(" +-=");
  hex(i1 + -i2);
  puts(" -+=");
  hex(-i1 + i2);
  puts(" --=");
  hex(-i1 + -i2);
  puts("\r\nSubtraktion:    ++=");
  hex(i1 - i2);
  puts(" +-=");
  hex(i1 - -i2);
  puts(" -+=");
  hex(-i1 - i2);
  puts(" --=");
  hex(-i1 - -i2);
  puts("\r\nMultiplikation: ++=");
  hex(i1 * i2);
  puts(" +-=");
  hex(i1 * -i2);
  puts(" -+=");
  hex(-i1 * i2);
  puts(" --=");
  hex(-i1 * -i2);
  if (i2==0)
    puts("\r\nDivision und Modulo: Teiler=0!");
  else
    {
    puts("\r\nDivision:       ++=");
    hex(i1 / i2);
    puts(" +-=");
    hex(i1 / -i2);
    puts(" -+=");
    hex(-i1 / i2);
    puts(" --=");
    hex(-i1 / -i2);
    puts("\r\nModulo:         ++=");
    hex(i1 % i2);
    puts(" +-=");
    hex(i1 % -i2);
    puts(" -+=");
    hex(-i1 % i2);
    puts(" --=");
    hex(-i1 % -i2);
    }
  getchar();
  }

/* === Logik ========================================================== */

logic(int i1,int i2)
/*----------------*/
  {
  puts("\r\nLogik mit ");
  hex(i1);
  putchar('/');
  hex(-i1);
  puts(" und ");
  hex(i2);
  putchar('/');
  hex(-i2);
  puts(":\r\nDisjunktion:   ++=");
  hex(i1 | i2);
  puts(" +-=");
  hex(i1 | -i2);
  puts(" -+=");
  hex(-i1 | i2);
  puts(" --=");
  hex(-i1 | -i2);
  puts("\r\nExclusiv-Oder: ++=");
  hex(i1 ^ i2);
  puts(" +-=");
  hex(i1 ^ -i2);
  puts(" -+=");
  hex(-i1 ^ i2);
  puts(" --=");
  hex(-i1 ^ -i2);
  puts("\r\nKonjunktion:   ++=");
  hex(i1 & i2);
  puts(" +-=");
  hex(i1 & -i2);
  puts(" -+=");
  hex(-i1 & i2);
  puts(" --=");
  hex(-i1 & -i2);
  getchar();
  }

log_int(int i1,int i2)
/*------------------*/
  {
  puts("\r\nWerte, vergleiche ");
  hex(i1);
  puts(" mit ");
  hex(i2);
  puts(":\r\n==:");
  log(i1==i2);
  puts("\r\n!=:");
  log(i1!=i2);
  puts("\r\n<:");
  log(i1<i2);
  puts("\r\n<=:");
  log(i1<=i2);
  puts("\r\n>:");
  log(i1>i2);
  puts("\r\n>=:");
  log(i1>=i2);
  getchar();
  }

log_ptr(char *p1,char *p2)
/*----------------------*/
  {
  puts("\r\nPointer, vergleiche ");
  hex(p1);
  puts(" mit ");
  hex(p2);
  puts(":\r\n==:");
  log(p1==p2);
  puts("\r\n!=:");
  log(p1!=p2);
  puts("\r\n<:");
  log(p1<p2);
  puts("\r\n<=:");
  log(p1<=p2);
  puts("\r\n>:");
  log(p1>p2);
  puts("\r\n>=:");
  log(p1>=p2);
  getchar();
  }

log(int l)
/*------*/
  {
  if (l)
    puts("wahr");
  else
    puts("falsch");
  }

/* === Ausgabefunktionen ============================================== */

hex(int n)
/*------*/
  {
  nib(n>>12);
  nib(n>>8);
  nib(n>>4);
  nib(n);
  putchar('(');
  if (n<0)
    {
    n=-n;
    putchar('-');
    }
  else
    putchar('+');
  nib(n>>12);
  nib(n>>8);
  nib(n>>4);
  nib(n);
  putchar(')');
  }

nib(int n)
/*------*/
  {
  n=n&15;
  if (n<10)
    putchar(n+'0');
  else
    putchar(n-10+'A');
  }

/* === Ende =========================================================== */
