/************************************************************************
 *  TEST_CNV.C                                                          *
 *                      Test von Umwandlungs-Funktionen                 *
 *                      ===============================                 *
 *                                                                      *
 *  14.06.93    Bodo Wenzel     Erstellung                              *
 ************************************************************************/

/* === Einfgedateien ================================================= */

#include "stdio.h"
#include "stdlib.h"

/* === Funktionsprototypen ============================================ */

i2s(int i);
s2i(char *s);
iss(int i,char *s1,char *s2);
ssii(char *s1,char *s2,int i1,int i2);
hex(int n);
nib(int n);

/* === M A I N ======================================================== */

main()
/*--*/
  {
  i2s(0);
  i2s(123);
  i2s(-123);
  i2s(32767);
  i2s(-32767);

  s2i("");
  s2i("0");
  s2i("+0");
  s2i("-0");
  s2i("1111011");
  s2i("+1111011");
  s2i("-1111011");
  s2i("173");
  s2i("+173");
  s2i("-173");
  s2i("123");
  s2i("+123");
  s2i("-123");
  s2i("7B");
  s2i("+7B");
  s2i("-7B");
  s2i("9999");
  s2i("FFF");
  s2i("111111111111111");
  s2i("77777");
  s2i("32767");
  s2i("7FFF");
  s2i("Teststring");
  s2i("-Teststring");
  s2i("+Teststring");
  return(0);
  }

/* === Konvertierungen ================================================ */

i2s(int i)
/*------*/
  {
  char  s[100];

  itostr(s,2,i);
  iss(i,"B",s);
  itostr(s,8,i);
  iss(i,"O",s);
  itostr(s,10,i);
  iss(i,"D",s);
  itostr(s,16,i);
  iss(i,"H",s);
  getchar();
  }

s2i(char *s)
/*--------*/
  {
  int   i,v;

  i=0;
  v=strtoi(s,2,&i);
  ssii(s,"B",v,i);
  i=0;
  v=strtoi(s,8,&i);
  ssii(s,"O",v,i);
  i=0;
  v=strtoi(s,10,&i);
  ssii(s,"D",v,i);
  i=0;
  v=strtoi(s,16,&i);
  ssii(s,"H",v,i);
  getchar();
  }

iss(int i,char *s1,char *s2)
/*------------------------*/
  {
  hex(i);
  putchar('(');
  puts(s1);
  puts(")=>\"");
  puts(s2);
  puts("\"\r\n");
  }

ssii(char *s1,char *s2,int i1,int i2)
/*---------------------------------*/
  {
  puts("\"");
  puts(s1);
  puts("\"(");
  puts(s2);
  puts(")=>");
  hex(i1);
  putchar('(');
  hex(i2);
  puts(")\r\n");
  }

/* === Ausgabefunktionen ============================================== */

hex(int n)
/*------*/
  {
  if (n<0)
    {
    n=-n;
    putchar('-');
    }
  else
    putchar('+');
  nib(n>>12);
  nib(n>>8);
  nib(n>>4);
  nib(n);
  }

nib(int n)
/*------*/
  {
  n=n&15;
  if (n<10)
    putchar(n+'0');
  else
    putchar(n-10+'A');
  }

/* === Ende =========================================================== */
