/************************************************************************
 *  TEST_SCN.C                                                          *
 *                      Test von sscanf()-Funktion                      *
 *                      ==========================                      *
 *                                                                      *
 *  17.06.93    Bodo Wenzel     Erstellung                              *
 ************************************************************************/

/* === Einfgedateien ================================================= */

#include "stdio.h"
#include "string.h"

/* === Funktionsprototypen ============================================ */

scn_s(char *s,char *f);
scn_i(char *s,char *f);
hex(int n);
nib(int n);

/* === M A I N ======================================================== */

main()
/*--*/
  {
  scn_s("","");
  scn_s("","%");
  scn_s("x","%");
  scn_s("%","%");
  scn_s("%","%%");
  scn_s("Teststring","Test");
  getchar();

  scn_s("","S%sS");
  scn_s("Test","S%sS");
  scn_s("STestS","S%sS");
  scn_s("S Test S","S%sS");
  scn_s("S Teststring S","S%sS");
  scn_s("S Test S","S %s S");
  scn_s("S Teststring S","S %s S");
  scn_s("STestS","S%4sS");
  scn_s("STeststringS","S%4sS");
  scn_s("S Test S","S%4sS");
  scn_s("S Teststring S","S%4sS");
  scn_s("STestS","S%11sS");
  scn_s("STeststringS","S%11sS");
  scn_s("S Test S","S%11sS");
  scn_s("S Teststring S","S%11sS");
  getchar();

  scn_s("","C%cC");
  scn_s("Test","C%cC");
  scn_s("CTestC","C%cC");
  scn_s("C Test C","C%cC");
  scn_s("CTC","C%cC");
  scn_s("C C","C%cC");
  scn_s("CTestC","C%4cC");
  scn_s("CTeststringC","C%4cC");
  scn_s("C Test C","C%4cC");
  scn_s("C Tst C","C %4c C");
  scn_s("C Te C","C%4cC");
  scn_s("CTeststringC","C%11cC");
  scn_s("C TeststringC","C%11cC");
  scn_s("CTeststring C","C%11cC");
  getchar();

  scn_i("","5%d5");
  scn_i("5","5%d5");
  scn_i("567","5%d5");
  scn_i("5675","5%d5");
  scn_i("5567","5%d5");
  scn_i("55675","5%d5");
  scn_i("567 5","5%d5");
  scn_i("5 567","5%d5");
  scn_i("5 567 5","5%d5");
  scn_i("5 567 5","5 %d5");
  scn_i("5 567 5","5%d 5");
  scn_i("5 567 5","5 %d 5");
  getchar();

  scn_i("","5%3d5");
  scn_i("5","5%3d5");
  scn_i("5567","5%3d5");
  scn_i("5 567","5%3d5");
  scn_i("567 5","5%3d5");
  scn_i("55675","5%3d5");
  scn_i("5 5675","5%3d5");
  scn_i("5567 5","5%3d5");
  scn_i("5 567 5","5%3d5");
  getchar();

  scn_i("","8%x8");
  scn_i("8","8%x8");
  scn_i("89A","8%x8");
  scn_i("89A8","8%x8");
  scn_i("889A","8%x8");
  scn_i("889A8","8%x8");
  scn_i("89A 8","8%x8");
  scn_i("8 89A","8%x8");
  scn_i("8 89A 8","8%x8");
  scn_i("8 89A 8","8 %x8");
  scn_i("8 89A 8","8%x 8");
  scn_i("8 89A 8","8 %x 8");
  getchar();

  scn_i("","8%3x8");
  scn_i("8","8%3x8");
  scn_i("889A","8%3x8");
  scn_i("8 89A","8%3x8");
  scn_i("89A 8","8%3x8");
  scn_i("889A8","8%3x8");
  scn_i("8 89A8","8%3x8");
  scn_i("889A 8","8%3x8");
  scn_i("8 89A 8","8%3x8");
  getchar();
  return(0);
  }

/* === Tests von sscanf() ============================================= */

scn_s(char *s,char *f)
/*------------------*/
  {
  char  b[100];
  int   i;

  strcpy(b,"******************************");
  i=sscanf(s,f,b);
  putchar('"');
  puts(f);
  puts("\"(\"");
  puts(s);
  puts("\")=>\"");
  puts(b);
  puts("\"(");
  hex(i);
  puts(")\r\n");
  }

scn_i(char *s,char *f)
/*------------------*/
  {
  int   i,v;

  v=123;
  i=sscanf(s,f,&v);
  putchar('"');
  puts(f);
  puts("\"(\"");
  puts(s);
  puts("\")=>");
  hex(v);
  putchar('(');
  hex(i);
  puts(")\r\n");
  }

/* === Ausgabefunktionen ============================================== */

hex(int n)
/*------*/
  {
  if (n<0)
    {
    n=-n;
    putchar('-');
    }
  else
    putchar('+');
  nib(n>>12);
  nib(n>>8);
  nib(n>>4);
  nib(n);
  }

nib(int n)
/*------*/
  {
  n=n&15;
  if (n<10)
    putchar(n+'0');
  else
    putchar(n-10+'A');
  }

/* === Ende =========================================================== */
