/************************************************************************
 *  TEST_CTL.C                                                          *
 *                          Test der Kontrollanweisungen                *
 *                          ============================                *
 *                                                                      *
 *  13.06.93    Bodo Wenzel     Erstellung                              *
 ************************************************************************/

func()
  {
  if (1)                /* "if"      ohne alles */
    ;
  if (1)                /* "if-else" ohne alles */
    ;
  else
    ;
  if (1)                /* "if"      mit einfachem Statement */
    123;
  if (1)                /* "if-else" mit einfachem Statement */
    123;
  else
    456;
  if (1)                /* "if"      mit Block */
    {
    int x;
    123;
    }
  if (1)                /* "if-else" mit Block */
    {
    int x;
    123;
    }
  else
    {
    int x;
    456;
    }

/* -------------------------------------------------------------------- */

  switch (2)            /*           ohne alles */
    {
    }
  switch (2)            /* "case"    ohne alles */
    {
    case 1:
    }
  switch (2)            /* "default" ohne alles */
    {
    default:
    }
  switch (2)            /* "case"    mit einfachem Statement */
    {
    case 1:
      123;
    }
  switch (2)            /* "default" mit einfachem Statement */
    {
    default:
      123;
    }
  switch (2)            /* c-d       mit einfachem Statement */
    {
    case 1:
      123;
    default:
      456;
    }
  switch (2)            /* d-c       mit einfachem Statement */
    {
    default:
      123;
    case 1:
      456;
    }
  switch (2)            /* c-c       mit einfachem Statement */
    {
    case 1:
      123;
    case 2:
      456;
    }
  switch (2)            /* c-cd      mit einfachem Statement */
    {
    case 1:
      123;
    case 2:
    default:
      456;
    }
  switch (2)            /* cc-d      mit einfachem Statement */
    {
    case 1:
    case 2:
      123;
    default:
      456;
    }
  switch (2)            /* c-d       mit "break" */
    {
    case 1:
      123;
      break;
    default:
      456;
    }
  switch (2)
    {
    case 1:
      break;
      123;
    default:
      456;
    }
  switch (2)
    {
    case 1:
      123;
    default:
      456;
      break;
    }
  switch (2)
    {
    case 1:
      123;
    default:
      break;
      456;
    }
  switch (2)            /* c-c     mit "break" */
    {
    case 1:
      123;
      break;
    case 2:
      456;
    }
  switch (2)
    {
    case 1:
      break;
      123;
    case 2:
      456;
    }
  switch (2)
    {
    case 1:
      123;
    case 2:
      456;
      break;
    }
  switch (2)
    {
    case 1:
      123;
    case 2:
      break;
      456;
    }
  switch (2)            /* c-c-d   mit "break" */
    {
    case 1:
      123;
      break;
    case 2:
      789;
    default:
      456;
    }
  switch (2)
    {
    case 1:
      123;
    case 2:
      789;
      break;
    default:
      456;
    }
  switch (2)
    {
    case 1:
      123;
    case 2:
      789;
    default:
      456;
      break;
    }
  switch (2)            /* c-d     mit Block */
    {
    case 1:
      {
      int y;
      123;
      }
    default:
      456;
    }
  switch (2)
    {
    case 1:
      123;
    default:
      {
      int y;
      456;
      }
    }
  switch (2)            /* c-c     mit Block */
    {
    case 1:
      {
      int y;
      123;
      }
    case 2:
      456;
    }
  switch (2)
    {
    case 1:
      123;
    case 2:
      {
      int y;
      456;
      }
    }
  switch (2)            /* c-d     mit Block und "break" */
    {
    case 1:
      {
      int y;
      123;
      break;
      }
    default:
      456;
    }
  switch (2)
    {
    case 1:
      123;
    default:
      {
      int y;
      456;
      break;
      }
    }
  switch (2)            /* c-c     mit Block und "break" */
    {
    case 1:
      {
      int y;
      123;
      break;
      }
    case 2:
      456;
    }
  switch (2)
    {
    case 1:
      123;
    case 2:
      {
      int y;
      456;
      break;
      }
    }

/* -------------------------------------------------------------------- */

  while (3)             /* ohne alles */
    ;
  while (3)             /* mit einfachem Statement */
    123;
  while (3)             /* mit "continue" */
    continue;
  while (3)             /* mit "break" */
    break;
  while (3)             /* mit Block */
    {
    int x;
    123;
    }
  while (3)             /* mit Block und "continue" */
    {
    int x;
    123;
    continue;
    456;
    }
  while (3)             /* mit Block und "break" */
    {
    int x;
    123;
    break;
    456;
    }

/* -------------------------------------------------------------------- */

  do                    /* ohne alles */
    ;
  while (4);
  do                    /* mit einfachem Statement */
    123;
  while (4);
  do                    /* mit "continue" */
    continue;
  while (4);
  do                    /* mit "break" */
    break;
  while (4);
  do                    /* mit Block */
    {
    int x;
    123;
    456;
    }
  while (4);
  do                    /* mit Block und "continue" */
    {
    int x;
    123;
    continue;
    456;
    }
  while (4);
  do                    /* mit Block und "break" */
    {
    int x;
    123;
    break;
    456;
    }
  while (4);

/* -------------------------------------------------------------------- */

  for (;;)              /* ohne alles */
    ;
  for (;;)              /* mit einfachem Statement */
    123;
  for (;;)              /* mit "continue" */
    continue;
  for (;;)              /* mit "break" */
    break;
  for (321; 654; 987)   /* ohne alles */
    ;
  for (321; 654; 987)   /* mit einfachem Statement */
    123;
  for (321; 654; 987)   /* mit "continue" */
    continue;
  for (321; 654; 987)   /* mit "break" */
    break;
  for (321; 654; 987)   /* mit Block */
    {
    int x;
    123;
    456;
    }
  for (321; 654; 987)   /* mit Block und "continue" */
    {
    int x;
    123;
    continue;
    456;
    }
  for (321; 654; 987)   /* mit Block und "break" */
    {
    int x;
    123;
    break;
    456;
    }

/* -------------------------------------------------------------------- */

  return;               /* ohne alles */
  return 123;           /* mit Wert */
  }

/* --- Ende ----------------------------------------------------------- */
